Make testing library dynamic. Refactor DEPLOY.sh
[anna.git] / example / diameter / launcher / DEPLOY.sh
index c6d58f1..7ea9942 100755 (executable)
 #!/bin/bash
 
-# Functions & variables
-SETUPS_DIR=../../../source/diameter/stack/setups
-MSGDTD=../../../include/anna/diameter/codec/message.dtd
-DCTDTD=../../../include/anna/diameter/stack/dictionary.dtd
-BASE_PROT=commands_baseProtocol.xml
-#EXEC=/opt/bin/anna/example_diameter_launcher
-EXEC=./debug/example_diameter_launcher
-DPATH_dflt=$HOME/ADL
+#############
+# VARIABLES #
+#############
+SCR_DIR=`readlink -f $(dirname $0)`
+PROJECT_ROOT=$(readlink -f ../../..)
+SETUPS_DIR=$PROJECT_ROOT/source/diameter/stack/setups
+MSGDTD=$PROJECT_ROOT/include/anna/diameter/codec/message.dtd
+DCTDTD=$PROJECT_ROOT/include/anna/diameter/stack/dictionary.dtd
+SERVICES=$SCR_DIR/resources/services_examples
+STACK_EXAMPLES=$SCR_DIR/resources/stack_examples
+SRVDTD=$SERVICES/services.dtd
+VARIANT=
 
+#############
+# FUNCTIONS #
+#############
 _exit () {
-   echo
-   echo $1
-   echo
-   exit
+   echo -e "\n$1\n"
+   exit 1
 }
 
+usage () {
+  echo "Usage: $0 [deployment_type: a|b|f|s] [deployment_path]"
+  echo
+  echo "       deployment_type:"
+  echo "          a=advanced"
+  echo "          b=basic"
+  echo "          f=function test client"
+  echo "          s=system test client"
+  echo "       deployment_path:"
+  echo "          non-existent path directory."
+  echo
+  echo "       For example:"
+  echo "          $0 b $HOME/ADML-basicServer"
+  echo "          $0 b $HOME/ADML-MMSbalancer"
+  echo "          $0 f $HOME/ADML-tester"
+  echo "          $0 s $HOME/ADML-stress-client"
+  echo
+  exit 0
+}
+# $1: deployment type
 createRunScript () {
+  # Basic launcher 'run.sh' will be created at deployment configuration: 
+  [ "$1" = "b" ] && return
 
-  echo "#!/bin/bash" > run.sh
-  echo "EXE=\`cat .exe 2>/dev/null\`" >> run.sh
-  echo "STARTED=\`ps -fea | grep \"\$EXE\" | grep -v grep\`" >> run.sh
-  echo "[ \"\$EXE\" != \"\" -a \"\$STARTED\" != \"\" ] && { echo \"Already started!\"; echo \"\$STARTED\" ; exit ; }" >> run.sh
-  echo "./pre-start.sh" >> run.sh
-  echo "> launcher.traces" >> run.sh
-  echo "EXE=\"./ADL-launcher\"" >> run.sh
-  echo "echo \$EXE > .exe"  >> run.sh
-  echo >> run.sh
-  echo -n "\$EXE " >> run.sh
-  for i in `cat args.txt | grep -v "^#"`
-  do
-    echo -n "$i " >> run.sh
-  done
-  echo "&" >> run.sh
-  chmod a+x run.sh
-  rm args.txt
-}
+  local other=
+  [ "$1" = "a" ] && other="--httpServer \`grep -v ^# .httpServer\`"
+  [ "$1" = "f" ] && ln -s ADML-launcher $EXE
+  [ "$1" = "s" ] && { other="--disableLogs"; ln -s ADML-launcher $EXE ; }
+
+  echo "Creating 'run.sh' script ..."
+
+  cat << EOF > run.sh
+#!/bin/bash
+cd \`dirname \$0\`
+EXE=$EXE
+STARTED=\`pgrep \$EXE$ 2>/dev/null\`
+[ \$? -eq 0 ] && { echo "Already started!"; echo "\$STARTED" ; exit 1 ; }
+./pre-start.sh
+0> launcher.trace
+rm -f counters/* test-reports/*
+# Execution line:
+export LD_LIBRARY_PATH=\$PWD/dynlibs
+./\$EXE --services services.xml --cntDir counters --tmDir test-reports $other &
+echo \$! > .pid
+EOF
 
-createDictionaryPaths () {
-
-
-for i in stacks/*commands*xml
-  do
-    stacks/dependence.sh $i >/dev/null
-    stack=`basename $i`
-    if test "$stack" != "$BASE_PROT"
-    then
-      > .dictionary__${stack}
-      for j in `cat ${i}.dep`
-      do
-        echo -n "${j}," >> .dictionary__${stack}
-      done
-      echo "stacks/$BASE_PROT,stacks/${stack}" >> .dictionary__${stack}
-    fi
-  done
-
-  # Default:
-  ln -s .dictionary__commands_qosControl.xml .dictionary
+  chmod a+x run.sh
 }
 
 #############
 # EXECUTION #
 #############
+cd $SCR_DIR
+
 echo
 echo "---------------------------------------"
-echo "Anna Diameter Launcher (ADL) deployment"
+echo "Anna Diameter Launcher (ADML) deployment"
 echo "---------------------------------------"
+[ "$1" = "--help" -o "$1" = "-h" ] && usage
+echo " (--help or -h for more info)"
 echo
-echo "Input deployment path [$DPATH_dflt]:"
-read DPATH
-[[ "$DPATH" = "" ]] && DPATH=$DPATH_dflt
-[[ -d $DPATH ]] && _exit "The path '$DPATH' already exists. Remove it before continue..."
-
 echo "Basic checkings ..."
-#[[ ! -f $EXEC ]] && _exit "Anna Diameter Launcher (ADL) is not installed in the system. Execute 'sudo scons install' for 'anna' suite."
-[[ ! -f $EXEC ]] && _exit "Anna Diameter Launcher (ADL) is not linked. Execute 'scons' for 'anna' suite."
-[[ ! -d $SETUPS_DIR ]] && _exit "Diameter stacks not found ($SETUPS_DIR). Perhaps you executed this script out of its parent path."
 
-echo "Copying ..."
+# Get variant and main executables:
+[ -f $SCR_DIR/release/example_diameter_launcher ] && VARIANT=release
+[ -f $SCR_DIR/debug/example_diameter_launcher ] && VARIANT=debug
+[ -z "$VARIANT" ] && _exit "Cannot locate neither 'release' nor 'debug' variant !"
+echo "Variant: $VARIANT"
+ADML_EXEC=$SCR_DIR/$VARIANT/example_diameter_launcher
+STACKMGMT_EXEC=$(readlink -f $SCR_DIR/../stackManagement/$VARIANT/example_diameter_stackManagement)
+
+[ ! -d $SETUPS_DIR ] && _exit "Diameter stacks not found ($SETUPS_DIR)."
+
+echo
+if [ "$1" = "" ]
+then
+  echo
+  echo "Deploy one of these versions:"
+  echo
+  echo " (a)dvanced version:     includes burst management script and templates for different scenarios. Automatic configuration during start."
+  echo " (b)asic version:        4 types of launcher (client, server, balancer, dummy), lightly configured and managed through SIGURS2 method."
+  echo " (f)unction test client: special client with regexp scheduler script based on splitted traffic logs. Requires a server to perform the tests."
+  echo " (s)ystem test client:   special client for stress testing. Requires a server/s to perform the tests."
+  echo
+  echo "Input option [b]:"
+  read option
+  [ "$option" = "" ] && option=b
+else
+  option=$1
+fi
+
+case $option in
+  a)
+    echo "Advanced deployment"
+    DEPLOYMENTS_DIR=deployments/advanced
+    DPATH_dflt=$HOME/ADML-advanced
+  ;;
+
+  b)
+    echo "Basic deployment"
+    DEPLOYMENTS_DIR=deployments/basic
+    DPATH_dflt=$HOME/ADML-basic
+  ;;
+
+  f)
+    echo "FT deployment"
+    DEPLOYMENTS_DIR=deployments/ft-client
+    DPATH_dflt=$HOME/ADML-ft-client
+  ;;
+
+  s)
+    echo "ST deployment"
+    DEPLOYMENTS_DIR=deployments/st-client
+    DPATH_dflt=$HOME/ADML-st-client
+  ;;
+
+  *)
+    _exit "Invalid deployment type '$option' !!"
+  ;;
+esac
+
+echo
+if [ "$2" = "" ]
+then
+  echo "Input deployment path [$DPATH_dflt]:"
+  read DPATH
+  [ "$DPATH" = "" ] && DPATH=$DPATH_dflt
+else
+  DPATH=$2
+fi
+
+[ -d $DPATH ] && _exit "The installation path '$DPATH' must not exists."
+EXE=`basename $DPATH`
+
+echo "Copying to '$DPATH' ..."
 mkdir -p $DPATH
 mkdir -p $DPATH/stacks
-cp $EXEC $DPATH/ADL-launcher
-cp resources/* $DPATH
+mkdir -p $DPATH/DTDs
+mkdir -p $DPATH/counters
+mkdir -p $DPATH/test-reports
+
+# Dynamic libs:
+mkdir -p $DPATH/dynlibs
+DYNLIBS=( $(find $PROJECT_ROOT -name "*.so" | grep -w $VARIANT) )
+
+for dynlib in ${DYNLIBS[@]}
+do
+  dynlib_bn=$(basename $dynlib)
+  if [ "$dynlib_bn" != "libanna_dynamicLauncherProcedure.so" ]
+  then
+    cp $dynlib $DPATH/dynlibs
+  else
+    ########## ADML Dynamic libs system ##########
+    # Create structure from $PROJECT_ROOT/dynamic/launcher
+    suffix_path=$(echo $dynlib | awk -F"$PROJECT_ROOT/dynamic/launcher/" '{ print $2 }')
+    target=$(dirname $DPATH/dynlibs/$(dirname $suffix_path))
+    mkdir -p $target
+    cp $dynlib $target
+
+    # Additional resources
+    dynlib_dn=$(dirname $dynlib)
+    dynlib_dn_dn=$(dirname $dynlib_dn)
+    cp $dynlib_dn_dn/*.xml $target 2>/dev/null
+    cp $dynlib_dn_dn/dynamic.suffix $target 2>/dev/null
+    cp -r $dynlib_dn_dn/services $target 2>/dev/null
+  fi
+done
+
+# ADML dynamic libs selection script:
+cp $SCR_DIR/resources/scripts/select_dynlib.sh $DPATH/dynlibs/select.sh
+
+# Default dynamic library:
+cd $DPATH/dynlibs
+ln -s default/libanna_dynamicLauncherProcedure.so
+cd - >/dev/null
+
+# Basic setup:
+[ "$option" = "b" ] && mkdir -p $DPATH/services
+
+# Copy executables:
+cp $ADML_EXEC $DPATH/ADML-launcher
+[ ! -f $DPATH/stacks/stack-mgmt ] && cp $STACKMGMT_EXEC $DPATH/stacks/stack-mgmt
+
+# Copy resources:
+cp -rL $DEPLOYMENTS_DIR/* $DPATH
 cp $SETUPS_DIR/*xml $DPATH/stacks
 cp $SETUPS_DIR/*sh $DPATH/stacks
 cp $SETUPS_DIR/readme.txt $DPATH/stacks
-cp $MSGDTD $DPATH
-cp $DCTDTD $DPATH
+mkdir $DPATH/stacks/other_examples
+cp $STACK_EXAMPLES/* $DPATH/stacks/other_examples 
+cp $MSGDTD $DPATH/DTDs
+cp $DCTDTD $DPATH/DTDs
+cp $SRVDTD $DPATH/DTDs
+[ "$option" = "b" ] && cp $SERVICES/* $DPATH/services
 
 echo "Preparing ..."
 cd $DPATH
-createRunScript
-createDictionaryPaths
+createRunScript $option
+stacks/makeAutonomous.sh commands_qosControl.xml stacks/stack-mgmt >/dev/null
+ln -s stacks/autonomous.commands_qosControl.xml dictionary.xml
 cd - >/dev/null
 
+if [ "$option" = "s" ]
+then
+  cd $DPATH
+  ln -s services_example services
+  mv run.sh .run-one.sh
+  mv run_all.sh run.sh
+  mv operation.sh .operation-one.sh
+  mv operation_all.sh operation.sh
+  rm dictionary.xml
+  cd - >/dev/null
+fi
+
 # Help:
+echo "Done !"
+echo "(see README at '$DPATH')"
 echo
-echo "Go to '$DPATH' and see README file"
-echo
-echo "Done!"
-echo
-echo
-